const co = require('co');

// jasmine.DEFAULT_TIMEOUT_INTERVAL = 30000;

// console.warn = () => null;

global.pFn = result => jest.fn(() => Promise.resolve(result));
global.epFn = msg => jest.fn(() => Promise.reject(new Error(msg)));
global.fn = result => jest.fn(() => result);
global.efn = msg => jest.fn(() => {
  throw new Error(msg);
});

global.asyncTest = (title, handler) => {
  test(title, asyncTest.bind(null, handler));
};

expect.extend({
  toBeObj(received) {
    const isObject = typeof received === 'object' && received !== null;
    const message = isObject
      ? `expected ${received} not to be object`
      : `expected ${received} to be object`;

    return {
      message: () => message,
      pass: isObject
    };
  },
  toBeFunc(received) {
    const isFunction = typeof received === 'function';
    const message = isFunction
      ? `expected ${received} not to be function`
      : `expected ${received} to be function`;

    return {
      message: () => message,
      pass: isFunction
    };
  },
  toBeArr(received) {
    const isArray = Array.isArray(received);
    const message = isArray
      ? `expected ${received} not to be array`
      : `expected ${received} to be array`;

    return {
      message: () => message,
      pass: isArray
    };
  }
});

global.asyncTest.skip = (title, handler) => {
  test.skip(title, asyncTest.bind(null, handler));
};

global.asyncTest.only = (title, handler) => {
  test.only(title, asyncTest.bind(null, handler));
};

async function asyncTest(handler, done) {
  try {
    await handler();
    done();
  } catch (error) {
    done.fail(error)
  }
}
